﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	
'	Private b4xVectEdit_component1, b4xVectEdit_component2, b4xVectEdit_component3, b4xVectEdit_component4  As b4xVectEdit_component
	Public pnlBase As B4XView
	Private B4XComboBox1 As B4XComboBox
	Private mapBases As Map
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
	mapBases.Initialize
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	mapBases.Put("Size (11 x 6)",Array(11,6))
	mapBases.Put("Size (10 x 8)",Array(10,8))
	mapBases.Put("Size (12 x 10)",Array(12,10))
	mapBases.Put("Size (8 x 8)",Array(8,8))
	mapBases.Put("Size (10 x 6)",Array(10,6))
	B4XComboBox1.cmbBox.Items.Add("Size (11 x 6)")
	B4XComboBox1.cmbBox.Items.Add("Size (10 x 8)")
	B4XComboBox1.cmbBox.Items.Add("Size (12 x 10)")
	B4XComboBox1.cmbBox.Items.Add("Size (8 x 8)")
	B4XComboBox1.cmbBox.Items.Add("Size (10 x 6)")

	'Initially 3 objects are created
	For x = 1 To 3
		Dim component As b4xVectEdit_component
		CreateComponent(component,"Comp_"&x,pnlBase,60dip,70dip,80dip,90dip) '
	Next

	For Each v As B4XView In pnlBase.GetAllViewsRecursive
		'We can modify the size of each object
		If GetType(v) = "anywheresoftware.b4j.objects.PaneWrapper$ConcretePaneWrapper$NonResizePane" Then
			Dim data As b4xVectEdit_rect = v.Tag
			Dim datas() As Object = data.Tag
			If 	datas(0) = "Comp_1"	 Then
				v.Width = 110dip
				v.Height = 200dip
				v.Left = 90dip
				v.Top = v.Left
			End If
			If 	datas(0) = "Comp_2"	 Then
				v.Width = 230dip
				v.Height = 80dip
				v.Left = 240dip
				v.Top = 50dip
			End If
			If 	datas(0) = "Comp_3"	 Then
				v.Width = 250dip
				v.Height = 130dip
				v.Left = 230dip
				v.Top = 180dip
			End If
			data.medidas.Text = v.Width&" X "&v.Height
			data.medidas.PrefWidth = v.Width
			data.medidas.PrefHeight = v.Height - 2 * 20dip
		End If
	Next
End Sub

Sub NumObj As Int
	Dim num As Int
	For Each v As B4XView In pnlBase.GetAllViewsRecursive
		If GetType(v) = "anywheresoftware.b4j.objects.PaneWrapper$ConcretePaneWrapper$NonResizePane" Then
			num = num + 1
		End If
	Next
	Return num
End Sub

Private Sub B4XComboBox1_SelectedIndexChanged (Index As Int)
	Dim medida() As Object = mapBases.Get(B4XComboBox1.cmbBox.Items.Get(B4XComboBox1.SelectedIndex))
	Dim ancho,largo As Double
	ancho = medida(0)
	largo = medida(1)
	pnlBase.Width = ancho*40
	pnlBase.Height = largo*40
End Sub

'Include an object with a specific size
Private Sub Button1_Click
	Dim component As b4xVectEdit_component
	CreateComponent(component,"Comp_"&(NumObj + 1),pnlBase,0,0,80dip,100dip)
End Sub

Sub CreateComponent (b4xVectEdit_comp As b4xVectEdit_component, name As String, TheRoot As B4XView,L As Int, T As Int, W  As Int, H As Int)
	Dim a As B4XView
	a = xui.CreatePanel("")
	TheRoot.AddView(a, L, T, W, H)
	b4xVectEdit_comp.Initialize(Me, name)
	b4xVectEdit_comp.DesignerCreateView(a, Null, Null)
End Sub