﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
'v.0.13 Circuit component object: a rectangle + pins

#Event: Click
#Event: LongClick

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
'	Public lista As List
	
	Public mRoot As B4XView
	Public mRect As b4xVectEdit_rect
	Public mPin1 As b4xVectEdit_pin
	
	Private DownX, DownY As Double, Dragging As Boolean, DraggingStart As Long 'ignore
	Private GridSize As Int = 5dip
	
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
'	lista.Initialize
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	mBase.SetColorAndBorder(xui.Color_Transparent, 1dip, xui.Color_ARGB(50, 0, 0, 0), 0)	'transparent container
    Tag = mBase.Tag
'''''''''''    mBase.Tag = Me
	mBase.Tag = Array(mBase.Left,mBase.Left + mBase.Width,mBase.Top, mBase.Height + mBase.Top)
	
	mRoot = xui.CreatePanel("mRoot")
'	mBase.Parent.AddView(mRoot, 0, 0, 100dip, 100dip)
	mBase.Parent.AddView(mRoot, 0, 0, mBase.Width, mBase.Height)
'	mRoot.Tag = Array(mBase.Left,mBase.Left + mBase.Width,mBase.Top, mBase.Height + mBase.Top)
	
	#if B4A
		Dim r As Reflector
		r.Target = mRoot
		r.SetOnTouchListener("mRoot_Touch") 'https://www.b4x.com/android/forum/threads/how-correct-crossplatform-mouse-object-moving-dragging-by-_touch-event.160800/#post-986957
	#End If
	mBase.RemoveViewFromParent
	
	'first figure as content of this component
	mRect.Initialize(Me, "mRect")
	mRect.DesignerCreateView(mRoot, Null, Null)
	mRect.Tag = Array(mEventName,0,mBase.Width,0, mBase.Height)
'	mRect.Tag = Array(mEventName,mBase.Left,mBase.Left + mBase.Width,mBase.Top, mBase.Height + mBase.Top)

	
	'second figure as content of this component
'	mPin1.Initialize(Me, "mPin1")
'	mPin1.DesignerCreateView(mRoot, Null, Null)
'	mPin1.mRoot.Top = mRect.mBase.Height / 2
	
	DownX = mRoot.Left
	DownY = mRoot.Top
End Sub

'TOUCH_ACTION_DOWN = 0
'TOUCH_ACTION_MOVE = 2
'TOUCH_ACTION_UP = 1
'TOUCH_ACTION_MOVE_NOTOUCH = 100
#if B4A
Private Sub mRoot_Touch (o As Object, ACTION As Int, x As Float, y As Float, motion As Object) As Boolean
#else
Private Sub mRoot_Touch (Action As Int, X As Float, Y As Float)
#end if
	If Action = mRoot.TOUCH_ACTION_DOWN Then
		Dragging = True
		DraggingStart = DateTime.Now
		DownX = X
		DownY = Y
	Else If Action = mRoot.TOUCH_ACTION_UP Then
		Dragging = False
		#if B4A
			If (DateTime.Now - DraggingStart) > 500 Then
				mRoot_LongClick
			Else
				mRoot_Click
			End If
		#end if
	Else If Dragging And Action = mRoot.TOUCH_ACTION_MOVE Then
		mRoot.Left = Max(0, Min(mRoot.Parent.Width - mRoot.Width, ApplyGrid(mRoot.Left + X - DownX)))
		mRoot.Top = Max(0, Min(mRoot.Parent.Height - mRoot.Height, ApplyGrid(mRoot.Top + Y - DownY)))
'		Dim obj As B4XView = Sender
'		Log(obj. )
'		Log(mRoot.Left)
'		Log(mRoot.Top)
	End If
    #if B4A
	Return True
    #end if
End Sub

Private Sub ApplyGrid (x As Int) As Int
	If GridSize > 0 Then
'		Log("mayor")
		Return x - (x Mod GridSize)
	End If
	Log("menor")
	Return x
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	mRoot.SetLayoutAnimated(0, 0, 0, Width, Height)
	mBase.Width = Width
	mBase.Height = Height
	Sleep(0)
End Sub

#if B4J
Private Sub mRoot_MouseClicked (EventData As MouseEvent)
	If EventData.PrimaryButtonPressed Then
		Log("mRoot click")
		If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
			CallSub(mCallBack, mEventName & "_Click")
		End If		

	Else if EventData.SecondaryButtonPressed Then
		Log("mRoot longclick")
		
		Dim wAnterior As Double =  mRoot.Width
		Dim hAnterior As Double = mRoot.Height
		mRoot.Width = hAnterior
		mRoot.Height = wAnterior
		mRect.medidas.PrefWidth = mRoot.Width
		mRect.medidas.PrefHeight = mRoot.Height - 2 * 20dip
		
'		If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
'			CallSub(mCallBack, mEventName & "_LongClick")
'		End If
	End If
	
End Sub
#else if B4A
Private Sub mRoot_Click
	Log("mRoot click")
	If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
		CallSub(mCallBack, mEventName & "_Click")
	End If
End Sub
Private Sub mRoot_LongClick
	Log("mRoot longclick")
	If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
		CallSub(mCallBack, mEventName & "_LongClick")
	End If
End Sub
#end if


